#ifndef LIDAR_TRACKER_LIDAR_TRACKER_H_
#define LIDAR_TRACKER_LIDAR_TRACKER_H_

#include "Eigen/Core"
#include "associator.h"
#include "lidar_tracker.h"
// #include "lidar_tracker.pb.h"
#include "types.h"
#include "track.h"

namespace lidar_tracker {

class LidarTracker {
 public:
  LidarTracker() = default;

  void Tracking(const ObservationsProto& observations);

  std::vector<TrackPtr> GetTracks() const;

 private:
  uint32_t NewTrackId();

  std::unique_ptr<Track> NewTrackFromObservation(
      const ObservationProto& observation);

  void UpdateTrackFromObservation(const ObservationProto& observation,
                                  Track* track);

  void CreateNewTracks(
      const std::vector<const ObservationProto*>& observations);

  void DeleteTimeOutTracks(double timestamp);

  uint32_t id_counter_ = 0;
  std::vector<TrackPtr> tracks_;
  Associator associator_;
};

}  // namespace lidar_tracker

#endif  // LIDAR_TRACKER_LIDAR_TRACKER_H_
